c25e303b03e38690fe0d61a2aec9fb60e83b3d01
[lttng-tools.git] / tests / stress / test_multi_sessions_per_uid_10app
1 #!/bin/bash
2 #
3 # Copyright (C) - 2013 David Goulet <dgoulet@efficios.com>
4 #
5 # This library is free software; you can redistribute it and/or modify it under
6 # the terms of the GNU Lesser General Public License as published by the Free
7 # Software Foundation; version 2.1 of the License.
8 # details.
9 #
10 # You should have received a copy of the GNU Lesser General Public License
11 # along with this library; if not, write to the Free Software Foundation, Inc.,
12 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
13
14
15 CURDIR=$(dirname $0)/
16 TESTDIR=$CURDIR/..
17 LAUNCH_APP="launch_ust_app"
18 SESSION_NAME="stress"
19 EVENT_NAME="tp:tptest"
20 LOG_FILE="sessiond.log"
21 CHANNEL_NAME="channel0"
22 NUM_TESTS=16
23 NR_APP=10
24 NR_SESSION=5
25 NR_LOOP=1000
26 COREDUMP_FILE=$(cat /proc/sys/kernel/core_pattern)
27 APPS_PID=
28
29 TEST_DESC="Stress test - $NR_SESSION sessions per UID with $NR_APP apps"
30
31 source $TESTDIR/utils/utils.sh
32
33 # MUST set TESTDIR before calling those functions
34
35 function enable_channel_per_uid()
36 {
37 local sess_name=$1
38 local channel_name=$2
39
40 $TESTDIR/../src/bin/lttng/$LTTNG_BIN enable-channel --buffers-uid -u $channel_name -s $sess_name >/dev/null 2>&1
41 ok $? "Enable channel $channel_name per UID for session $sess_name"
42 }
43
44 function check_sessiond()
45 {
46 if [ -z "$(pidof lt-lttng-sessiond)" ]; then
47 local str_date=$(date +%H%M%S-%d%m%Y)
48
49 diag "!!!The session daemon died unexpectedly!!!"
50 mv $LOG_FILE $LOG_FILE-$str_date
51 if [ -e $COREDUMP_FILE ]; then
52 mv $COREDUMP_FILE $COREDUMP_FILE-$str_date
53 fi
54 exit 1
55 fi
56 }
57
58 function start_sessiond()
59 {
60 local SESSIOND_BIN="lttng-sessiond"
61
62 validate_kernel_version
63 if [ $? -ne 0 ]; then
64 fail "Start session daemon"
65 BAIL_OUT "*** Kernel too old for session daemon tests ***"
66 fi
67
68 if [ -z $(pidof lt-$SESSIOND_BIN) ]; then
69 # We have to start it like this so the ulimit -c is used by this
70 # process. Also, we collect any error message printed out.
71 $TESTDIR/../src/bin/lttng-sessiond/$SESSIOND_BIN --quiet --background --consumerd32-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" --consumerd64-path="$TESTDIR/../src/bin/lttng-consumerd/lttng-consumerd" >$LOG_FILE 2>&1
72 status=$?
73 ok $status "Start session daemon"
74 fi
75 }
76
77 test_stress()
78 {
79 for b in $(seq 1 $NR_LOOP); do
80 for a in $(seq 1 $NR_SESSION); do
81 create_lttng_session_ok $SESSION_NAME-$a $TRACE_PATH
82 check_sessiond
83 enable_channel_per_uid $SESSION_NAME-$a $CHANNEL_NAME
84 check_sessiond
85 enable_ust_lttng_event_ok $SESSION_NAME-$a $EVENT_NAME
86 check_sessiond
87 start_lttng_tracing_ok $SESSION_NAME-$a
88 check_sessiond
89 done
90
91 for a in $(seq 1 $NR_SESSION); do
92 stop_lttng_tracing_ok $SESSION_NAME-$a
93 check_sessiond
94 destroy_lttng_session_ok $SESSION_NAME-$a
95 check_sessiond
96 done
97 done
98
99 return 0
100 }
101
102 function cleanup()
103 {
104 diag "Cleaning up!"
105 for p in ${APPS_PID}; do
106 kill -s SIGKILL ${p}
107 wait ${p} 2>/dev/null
108 done
109 APPS_PID=
110 stop_lttng_sessiond
111 }
112
113 function sighandler()
114 {
115 cleanup
116 rm $LOG_FILE
117 exit 1
118 }
119
120 trap sighandler SIGINT
121 trap sighandler SIGTERM
122
123 # Make sure we collect a coredump if possible.
124 ulimit -c unlimited
125
126 # MUST set TESTDIR before calling those functions
127 plan_tests $NUM_TESTS
128
129 print_test_banner "$TEST_DESC"
130
131 start_sessiond
132
133 diag "Starting applications"
134
135 # Start NR_APP applications script that will spawn apps non stop.
136 ./$TESTDIR/stress/$LAUNCH_APP $NR_APP &
137 APPS_PID="${APPS_PID} ${!}"
138
139 TRACE_PATH=$(mktemp -d)
140
141 test_stress
142 out=$?
143 if [ $out -ne 0 ]; then
144 cleanup
145 exit $out
146 fi
147
148 cleanup
149 rm -rf $TRACE_PATH
150 rm $LOG_FILE
151 exit 0
This page took 0.033209 seconds and 4 git commands to generate.